--==================================================================================  
-- Project:   PJ004672 - COWS Reporting   
-- Author:   Brad Settle  
-- Date:   08/03/2011  
-- Revised:   05/17/2012 bts4947  
--     replaced fo.PROD_TYPE_CD 'MN' with 'MP'  
--     08/02/2012  
--     added assigned & assignment date to 'CN' using parent FTN  
--     08/21/2012  
--     updated rts date to include submit rts from active tasks = 500  
-- ci554013 10/14/2013 - Added Decrypt to Customer Name for H5_folder change  
-- dlp0278 -- 7/21/2014 - Changed the Cancelled orders to show the Assigned as Display Name instead of Full Name  
--                        from LK_USER table to keep Cancels the same as other order types.  
-- Description:    
--     GOM Ops Report.  
--     Group Type:  GOM  
--     QueryNumber: 1 = Daily  
--         2 = Weekly  
--         3 = Monthly  
--         0 = Specify start date & end date: 'mm/dd/yyyy'  
--  
-- TEST: EXEC COWS_Reporting.dbo.sp_GOMRptOpsDataReport 1, 0, '2012-07-01', '2012-08-01'  
-- Updated By:   Md M Monir  
-- Updated Date: 03/19/2018  
-- Updated Reason: SCURD_CD/CSG_LVL_CD
-- Update date: <06/06/2018>
-- Updated by: Md M Monir  
-- Description: <To get H5 Data>  CTY_NME  
--==================================================================================  
ALTER Procedure [dbo].[sp_GOMRptOpsDataReport]   
 @secured   BIT=1,  
  @QueryNumber  INT = 2,  
  @inStartDtStr  VARCHAR(10)='',  
  @inEndDtStr   VARCHAR(10)=''  
  
AS  
BEGIN TRY  
  
 SET NOCOUNT ON;  
   
 DECLARE @startDate  Datetime  
 DECLARE @endDate  Datetime  
 DECLARE @today   Datetime  
 DECLARE @startDtStr  VARCHAR(10)   
 DECLARE @dayOfWeek  INT  
   
 IF @QueryNumber=0  
  BEGIN  
   SET @startDate=CONVERT(datetime, @inStartDtStr, 101)  
   SET @endDate=CONVERT(datetime, @inEndDtStr, 101)      
   -- Add 1 day to End Date in order to cover the End Date 24-hr period  
   SET @endDate=DATEADD(day, 1, @endDate)   
  END   
 ELSE IF @QueryNumber=1  
     BEGIN       
      -- e.g. Run date is '2011-06-15' , STRT_TMST >= 2011-06-15 00:00:00.000 and STRT_TMST < 2011-06-16 00:00:00.000  
   SET @startDate=cast(CONVERT(varchar(8), GETDATE(), 112) AS datetime)  
   SET @endDate=cast(CONVERT(varchar(8), DATEADD(day, 1, GETDATE()), 112) AS datetime)     
  END  
 ELSE IF @QueryNumber=2  
  BEGIN  
   -- e.g. Run date is '2011-06-21' 3rd day of the week  
   -- STRT_TMST >= 2011-06-12 00:00:00.000 and STRT_TMST < 2011-06-19 00:00:00.000  
   SET @today=GETDATE()  
   SET @dayOfWeek=DATEPART(dw, @today)  
   SET @startDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -(@dayOfWeek+6), @today), 112) As DateTime)  
   SET @endDate=cast(CONVERT(varchar(8), DATEADD(dd, -(@dayOfWeek-1), @today), 112) AS Datetime)  
  END  
 ELSE IF @QueryNumber=3  
  BEGIN      
     SET @today=DATEADD(MONTH,0,GETDATE())  
      -- e.g. Run date is the 1st day of each month   
      -- STRT_TMST >= 2011-05-01 00:00:00.000 and STRT_TMST < 2011-06-01 00:00:00.000  
     SET @startDtStr=SUBSTRING(CONVERT(VARCHAR(10), @today, 101),1,2) + '/01/' + CAST(YEAR(@today) AS VARCHAR(4));       
   SET @startDate=cast(@startDtStr AS datetime)  
   SET @endDate=cast(CONVERT(varchar(8), GETDATE()+1, 112) AS datetime)  
  END  
  
 --DECLARE @secured BIT=0 -- for testing purposes only  
  
 OPEN SYMMETRIC KEY FS@K3y   
 DECRYPTION BY CERTIFICATE S3cFS@CustInf0;   
  
 SELECT DISTINCT   
  CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(varchar (50),ipo.ORDR_ID)   
   WHEN o.ORDR_CAT_ID=2 THEN fo.FTN   
   WHEN o.ORDR_CAT_ID=6 THEN fo.FTN  
   END [Order Tracking No]     
  ,CASE  
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN ''   
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN ''   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NULL THEN ''   
   --ELSE ISNULL(CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)),CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)))   
   o.ORDR_CAT_ID  
         WHEN 6 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''  
       ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END  
      WHEN 2 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''  
       ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END  
      WHEN 1 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  h5f2.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NULL THEN  ''  
       ELSE  COALESCE(csd.CUST_NME,h5f2.CUST_NME,'') END     
    ELSE COALESCE(CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)),si.CUST_NME,si.CUST_NME2,'' )   
     
   END [Sprint Customer Name]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 AND o.H5_FOLDR_ID IS NULL AND o.H5_H6_CUST_ID IS NULL THEN ISNULL(h5f2.CUST_CTY_NME,'')   
   WHEN o.ORDR_CAT_ID=6 AND o.H5_FOLDR_ID IS NULL AND h5f.CUST_ID IS NULL THEN CONVERT(VARCHAR, DecryptByKey(oa.CTY_NME))  
   WHEN o.ORDR_CAT_ID=2 AND o.H5_FOLDR_ID IS NULL AND h5f.CUST_ID IS NULL THEN CONVERT(VARCHAR, DecryptByKey(oa.CTY_NME))  
   WHEN o.H5_FOLDR_ID IS NULL AND o.H5_H6_CUST_ID IS NOT NULL THEN ISNULL(h5f3.CUST_CTY_NME,'')   
   ELSE ISNULL(h5f.CUST_CTY_NME,'') END [H5 City]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 AND o.H5_FOLDR_ID IS NULL AND o.H5_H6_CUST_ID IS NULL THEN ISNULL(lkc2.CTRY_NME,'')   
   WHEN o.ORDR_CAT_ID=6 AND o.H5_FOLDR_ID IS NULL AND h5f.CUST_ID IS NULL THEN ISNULL(lkc4.CTRY_NME,'')  
   WHEN o.ORDR_CAT_ID=2 AND o.H5_FOLDR_ID IS NULL AND h5f.CUST_ID IS NULL THEN ISNULL(lkc4.CTRY_NME,'')  
   --WHEN o.H5_FOLDR_ID IS NULL AND o.H5_H6_CUST_ID IS NOT NULL THEN ISNULL(lkc3.CTRY_NME,'')   
   ELSE ISNULL(lkc.CTRY_NME,'') END [H5 Country]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lpt.PROD_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'') END [Product]  
  ,ISNULL(lkv.VNDR_NME,'') as [Vendor Name]  
  ,ISNULL(fo.TSUP_RFQ_NBR,'') [RFQ]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lot.ORDR_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'') END [Service Request Type]  
  --,ISNULL(fo.TTRPT_ACCS_TYPE_DES,'') [Access Type]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(CAST(llat.LOCAL_ACCS_TYPE_ID AS VARCHAR(10)),'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(CAST(fo.TTRPT_ACCS_TYPE_DES AS VARCHAR(10)),'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(CAST(fo.TTRPT_ACCS_TYPE_DES AS VARCHAR(10)),'') END [Access Type]  
  ,ISNULL(fo.TTRPT_SPD_OF_SRVC_BDWD_DES,'') [Order Bandwidth]  
  --,ISNULL(nc.PLN_NME,'') [Private Line Number]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CUST_CNTRC_SIGN_DT,101)  
   WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CUST_SIGNED_DT,101)  
   WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CUST_SIGNED_DT,101) END [Customer Contract Date]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CUST_ORDR_SBMT_DT,101)  
   WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CUST_ORDR_SBMT_DT,101)  
   WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CUST_ORDR_SBMT_DT,101) END [Customer Order Submit Date]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CUST_WANT_DT,101)  
   WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CUST_WANT_DT,101)  
   WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CUST_WANT_DT,101) END [Customer Want Date]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CUST_CMMT_DT,101)  
   WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CUST_CMMT_DT,101)  
   WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CUST_CMMT_DT,101) END [Customer Commit Date]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CREAT_DT,101)  
   WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CREAT_DT,101)  
   WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CREAT_DT,101) END [FSA Order Creation Date]  
  ,CASE  
   WHEN fo.ORDR_TYPE_CD='CN' AND fo.PRNT_FTN IS NOT NULL THEN ISNULL(cn.[Name],'')  
   ELSE ISNULL(lu.[DSPL_NME],'') END [Assigned]  
  ,CASE  
   WHEN fo.PRE_SBMT_CREAT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),fo.PRE_SBMT_CREAT_DT,121)   
   WHEN ms.PRE_SBMT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ms.PRE_SBMT_DT,121)  
   WHEN fo.ORDR_TYPE_CD='CN' AND fo.PRNT_FTN IS NOT NULL THEN CONVERT(VARCHAR(16),cn.ASMT_DT,121)  
   ELSE CONVERT(VARCHAR(16),uwa.ASMT_DT,121) END [Assigned Date]  
  ,ISNULL(lks.ORDR_STUS_DES,'') [Order Status]  
  ,ISNULL([Task Status],'') [Task Status]  
  ,ISNULL([Work Group],'') [Work Group]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.SALS_BR_NME,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(si.BR_CD,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(si.BR_CD,'') END [Sales Branch]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.SOI,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(si.SOI_CD,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(si.SOI_CD,'') END [Sales Office]  
  ,CASE   
   WHEN fo.PROD_TYPE_CD IN ('DN','DO','MP','MO','SN','SO') AND ms.PRE_SBMT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ms.PRE_SBMT_DT,121)  
   WHEN fo.PRE_SBMT_CREAT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),fo.PRE_SBMT_CREAT_DT,121)   
   ELSE CONVERT(VARCHAR(16),ont.[NOTE_DT],121) END  [Pre-Submit Date]  
  ,CASE   
   WHEN ont2.NOTE_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ont2.NOTE_DT,121)  
   WHEN fo.PROD_TYPE_CD IN ('DN','DO','MP','MO','SN','SO') AND ms.SBMT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ms.SBMT_DT,121)  
   ELSE CONVERT(VARCHAR(16),fo.ORDR_SBMT_DT,121) END  [Order Submit Date]  
  ,CASE   
   WHEN fo.PROD_TYPE_CD IN ('DN','DO','MP','MO','SN','SO') AND ms.PRE_SBMT_DT IS NOT NULL AND ms.SBMT_DT IS NOT NULL THEN Reporting.dbo.BusinessDayHourMinInterval(CONVERT(VARCHAR(16),ms.PRE_SBMT_DT,121),CONVERT(VARCHAR(16),ms.SBMT_DT,121))  
   WHEN fo.PRE_SBMT_CREAT_DT IS NOT NULL AND ont2.NOTE_DT IS NOT NULL THEN Reporting.dbo.BusinessDayHourMinInterval(CONVERT(VARCHAR(16),fo.PRE_SBMT_CREAT_DT,121),CONVERT(VARCHAR(16),ont2.NOTE_DT,121))    
   WHEN fo.PRE_SBMT_CREAT_DT IS NOT NULL AND fo.ORDR_SBMT_DT IS NOT NULL THEN Reporting.dbo.BusinessDayHourMinInterval(CONVERT(VARCHAR(16),fo.PRE_SBMT_CREAT_DT,121),CONVERT(VARCHAR(16),fo.ORDR_SBMT_DT,121))   
   ELSE '' END  [Duration]  
  ,CASE   
   WHEN fo.ORDR_ACTN_ID = 1 THEN ISNULL(CONVERT(VARCHAR(10),psrts.[PS RTS Date],121),'')  
   WHEN fo.ORDR_ACTN_ID = 2 THEN ISNULL(CONVERT(VARCHAR(10),srts.[S RTS Date],121),'') END [RTS Date]  
 FROM COWS.dbo.ORDR o with (nolock)   
  LEFT OUTER JOIN (SELECT bb.ORDR_ID,ORDR_ACTN_ID,FTN,RELTD_FTN,PRNT_FTN,ORDR_TYPE_CD,PROD_TYPE_CD,INSTL_VNDR_CD,  
        fcpl.TTRPT_ACCS_TYPE_DES,INTL_PL_CKT_TYPE_CD  
    ,fcpl.TTRPT_SPD_OF_SRVC_BDWD_DES,bb.CREAT_DT,CUST_SIGNED_DT,CUST_ORDR_SBMT_DT,CUST_WANT_DT,CUST_CMMT_DT,TSUP_RFQ_NBR,ORDR_SBMT_DT,PRE_SBMT_CREAT_DT  
   FROM COWS.dbo.FSA_ORDR bb WITH (NOLOCK)   
   LEFT OUTER JOIN [COWS].[dbo].[FSA_ORDR_CPE_LINE_ITEM] fcpl with (nolock) on fcpl.ORDR_ID = bb.ORDR_ID  
   WHERE ORDR_ACTN_ID <> 3  
   ) fo ON o.ORDR_ID = fo.ORDR_ID  
  --LEFT OUTER JOIN COWS.dbo.FSA_ORDR_CUST foc WITH (NOLOCK) ON fo.ORDR_ID = foc.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.ORDR_MS ms WITH (NOLOCK) ON o.ORDR_ID = ms.ORDR_ID  
  LEFT OUTER JOIN (SELECT ORDR_ID,ORDR_TYPE_ID,PROD_TYPE_ID,CREAT_DT,CUST_CNTRC_SIGN_DT,CUST_ORDR_SBMT_DT,CUST_WANT_DT,CUST_CMMT_DT,SALS_BR_NME,SOI  
    ,H5_CUST_ACCT_NBR   
   FROM COWS.dbo.IPL_ORDR WITH (NOLOCK) WHERE ORDR_STUS_ID <> 20  
   ) ipo ON o.ORDR_ID = ipo.ORDR_ID  
  LEFT OUTER JOIN ( SELECT ORDR_ID, MIN(CREAT_DT) [NOTE_DT] FROM COWS.dbo.ORDR_NTE WITH (NOLOCK) GROUP BY ORDR_ID)ont ON o.ORDR_ID = ont.ORDR_ID  
  LEFT OUTER JOIN ( SELECT ORDR_ID, MIN(CREAT_DT) [NOTE_DT] FROM COWS.dbo.ORDR_NTE WITH (NOLOCK) WHERE NTE_TXT = 'Completing GOM Submit Task.' GROUP BY ORDR_ID)ont2 ON o.ORDR_ID = ont2.ORDR_ID  
  --LEFT OUTER JOIN COWS.dbo.NRM_CKT nc WITH (NOLOCK) ON nc.FTN = fo.FTN  
  LEFT OUTER JOIN (SELECT DISTINCT ORDR_ID,LOCAL_ACCS_TYPE_ID   
   FROM COWS.dbo.IPL_ORDR_ACCS_INFO WITH (NOLOCK) WHERE LOCAL_ACCS_TYPE_ID IS NOT NULL  
   ) llat ON llat.ORDR_ID = o.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f3 WITH (NOLOCK) ON h5f3.CUST_ID = o.H5_H6_CUST_ID  
  LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f2 WITH (NOLOCK) ON h5f2.CUST_ID = ipo.H5_CUST_ACCT_NBR  
  LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=h5f2.H5_FOLDR_ID  AND csd.SCRD_OBJ_TYPE_ID=6  
  LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f WITH (NOLOCK) ON h5f.H5_FOLDR_ID = o.H5_FOLDR_ID  
  LEFT OUTER JOIN (
	SELECT o.ORDR_ID, o.CTRY_CD, o.CTY_NME,o.ORDR_ADR_ID
	FROM COWS.dbo.ORDR_ADR o WITH (NOLOCK) 
	WHERE CIS_LVL_TYPE = 'H5')oa ON oa.ORDR_ID = o.ORDR_ID      
  LEFT OUTER JOIN COWS.dbo.CUST_SCRD_DATA csd2 WITH (NOLOCK) ON csd2.SCRD_OBJ_ID = oa.ORDR_ADR_ID AND csd.SCRD_OBJ_TYPE_ID=14 
  LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc WITH (NOLOCK) ON lkc.CTRY_CD = h5f.CTRY_CD  
  LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc2 WITH (NOLOCK) ON lkc2.CTRY_CD = h5f2.CTRY_CD  
  LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc3 WITH (NOLOCK) ON lkc3.CTRY_CD = h5f3.CTRY_CD  
  LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc4 WITH (NOLOCK) ON lkc4.CTRY_CD = oa.CTRY_CD  
  --LEFT OUTER JOIN (SELECT nt.ORDR_ID, nt.NTE_ID, nt.CREAT_DT [ASMT_DT],nt.CREAT_BY_USER_ID [USER_ID] FROM COWS.dbo.ORDR_NTE nt WITH (NOLOCK)   
  -- JOIN (SELECT ORDR_ID,MAX(NTE_ID) NTE_ID FROM COWS.dbo.ORDR_NTE WITH (NOLOCK) WHERE NTE_TYPE_ID = 10 GROUP BY ORDR_ID) nte ON nte.NTE_ID = nt.NTE_ID  
  -- ) uwa ON uwa.ORDR_ID=o.ORDR_ID  
  LEFT OUTER JOIN (SELECT ORDR_ID,ASN_USER_ID [USER_ID],ASMT_DT FROM COWS.dbo.USER_WFM_ASMT WITH (NOLOCK) WHERE GRP_ID = 1) uwa ON uwa.ORDR_ID=o.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.LK_USER lu WITH (NOLOCK) ON uwa.USER_ID = lu.[USER_ID]  
  LEFT OUTER JOIN COWS.dbo.LK_FSA_ORDR_TYPE lfot WITH (NOLOCK) ON lfot.FSA_ORDR_TYPE_CD = fo.ORDR_TYPE_CD  
  LEFT OUTER JOIN COWS.dbo.LK_ORDR_STUS lks WITH (NOLOCK) ON lks.ORDR_STUS_ID=o.ORDR_STUS_ID  
  LEFT OUTER JOIN COWS.dbo.LK_ORDR_TYPE lot WITH (NOLOCK) ON lot.ORDR_TYPE_ID = ipo.ORDR_TYPE_ID  
  LEFT OUTER JOIN COWS.dbo.LK_FSA_PROD_TYPE lfpt WITH (NOLOCK) ON lfpt.FSA_PROD_TYPE_CD = fo.PROD_TYPE_CD  
  LEFT OUTER JOIN COWS.dbo.LK_PROD_TYPE lpt WITH (NOLOCK) ON lpt.PROD_TYPE_ID = ipo.PROD_TYPE_ID  
  LEFT OUTER JOIN COWS.dbo.LK_VNDR lkv WITH (NOLOCK) ON lkv.VNDR_CD = fo.INSTL_VNDR_CD  
  LEFT OUTER JOIN (SELECT DISTINCT o.ORDR_ID,lg.GRP_NME [Work Group],  
    CASE   
     WHEN TASK_NME = 'Bill Activated' THEN ''  
     ELSE TASK_NME + '-' + lsa.STUS_DES   
    END [Task Status]  
   FROM (SELECT ORDR_ID,WG_PTRN_ID,STUS_ID,CREAT_DT  
    FROM COWS.dbo.WG_PTRN_STUS WITH (NOLOCK)   
    WHERE STUS_ID=0   
   ) w  
   JOIN COWS.dbo.ORDR o WITH (NOLOCK) ON o.ORDR_ID=w.ORDR_ID  
   JOIN (  
    SELECT wpfs.ORDR_ID,WG_PTRN_ID,pfs.WG_PROF_ID,STUS_ID,wpfs.CREAT_DT FROM COWS.dbo.WG_PROF_STUS wpfs WITH (NOLOCK)   
    JOIN (SELECT ORDR_ID,MIN(WG_PROF_ID)[WG_PROF_ID],MIN(CONVERT(VARCHAR(16),CREAT_DT,121))[CREAT_DT] FROM COWS.dbo.WG_PROF_STUS  WITH (NOLOCK)  
    WHERE STUS_ID=0 GROUP BY ORDR_ID) pfs ON pfs.ORDR_ID=wpfs.ORDR_ID AND pfs.CREAT_DT=wpfs.CREAT_DT AND pfs.WG_PROF_ID=wpfs.WG_PROF_ID  
    WHERE wpfs.STUS_ID=0  
   ) wps ON wps.WG_PTRN_ID=w.WG_PTRN_ID AND wps.ORDR_ID=w.ORDR_ID -- AND wps.CREAT_DT=w.CREAT_DT   
     AND wps.STUS_ID=w.STUS_ID  
   LEFT OUTER JOIN (   
    SELECT DISTINCT at.ORDR_ID,mgt.GRP_ID,at.TASK_ID,at.WG_PROF_ID,STUS_ID [atSTUSID]  
    FROM COWS.dbo.ACT_TASK at WITH (NOLOCK)   
    LEFT OUTER JOIN (SELECT ORDR_ID,MIN(WG_PROF_ID)[WG_PROF_ID],MIN(CONVERT(VARCHAR(16),CREAT_DT,121))[CREAT_DT] FROM COWS.dbo.WG_PROF_STUS  WITH (NOLOCK)  
     GROUP BY ORDR_ID) pfs ON pfs.ORDR_ID=at.ORDR_ID --AND pfs.CREAT_DT=at.CREAT_DT   
     AND pfs.WG_PROF_ID=at.WG_PROF_ID  
    LEFT OUTER JOIN (SELECT TASK_ID, MIN(GRP_ID)[GRP_ID] FROM COWS.dbo.MAP_GRP_TASK WITH (NOLOCK) GROUP BY TASK_ID) mgt ON mgt.TASK_ID=at.TASK_ID  
    WHERE at.STUS_ID NOT IN (1, 2)  
    ) mat ON mat.ORDR_ID=wps.ORDR_ID AND mat.WG_PROF_ID=wps.WG_PROF_ID  
   LEFT OUTER JOIN COWS.dbo.LK_ORDR_STUS lks WITH (NOLOCK) ON lks.ORDR_STUS_ID=o.ORDR_STUS_ID  
   LEFT OUTER JOIN COWS.dbo.LK_GRP lg WITH (NOLOCK) ON lg.GRP_ID=mat.GRP_ID  
   LEFT OUTER JOIN COWS.dbo.LK_STUS lsw WITH (NOLOCK) ON lsw.STUS_ID=w.STUS_ID  
   LEFT OUTER JOIN COWS.dbo.LK_STUS lsa WITH (NOLOCK) ON lsa.STUS_ID=mat.[atSTUSID]  
   LEFT OUTER JOIN COWS.dbo.LK_STUS lsp WITH (NOLOCK) ON lsp.STUS_ID=wps.STUS_ID  
   LEFT OUTER JOIN COWS.dbo.LK_TASK lt WITH (NOLOCK) ON lt.TASK_ID=mat.TASK_ID  
  ) x ON x.ORDR_ID = o.ORDR_ID  
  LEFT OUTER JOIN (SELECT ORDR_ID,MAX(CREAT_DT)[PS RTS Date]  
    FROM COWS.dbo.ORDR_NTE  
    WHERE NTE_TXT = 'GOM user initiated RTS on this order.'   
    GROUP BY ORDR_ID    
  ) psrts ON psrts.ORDR_ID = o.ORDR_ID   
  LEFT OUTER JOIN (SELECT act.ORDR_ID,act.CREAT_DT [S RTS Date]   
   FROM [COWS].[dbo].[ACT_TASK] act WITH (NOLOCK)   
   WHERE act.ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID)  
    FROM (SELECT ACT_TASK_ID,ORDR_ID FROM [COWS].[dbo].[ACT_TASK] WITH (NOLOCK) WHERE TASK_ID=500 AND STUS_ID=0) act1   
   WHERE act1.ORDR_ID = act.ORDR_ID)  
  )srts ON srts.ORDR_ID = o.ORDR_ID    
  LEFT OUTER JOIN (SELECT ORDR_ID2,Name,ASMT_DT FROM (  
   SELECT [ORDR_ID2]  
    -- 10/9/14 commented lines and changed way Cancels are reported.  
    --,CASE   
    -- WHEN uwa.[ASN_USER_ID] IS NOT NULL THEN lku.DSPL_NME  
    -- ELSE c.[Name] END [Name]  
    --,CASE   
    -- WHEN uwa.[ASMT_DT] IS NOT NULL THEN uwa.[ASMT_DT]  
    -- ELSE c.[ASMT_DT] END [ASMT_DT]  
    ,lku.DSPL_NME [Name]  
    ,uwa.[ASMT_DT] [ASMT_DT]  
   FROM (SELECT ont.ORDR_ID, MAX(NTE_ID) [NTE_ID], MAX(ont.CREAT_DT) [ASMT_DT],ont.CREAT_BY_USER_ID [USER_ID],DSPL_NME [Name]  
     ,[ORDR_ID1],[ORDR_ID2]   
    FROM COWS.dbo.ORDR_NTE ont WITH (NOLOCK)  
    JOIN (SELECT fo1.ORDR_ID [ORDR_ID1],fo2.ORDR_ID [ORDR_ID2]  
     FROM COWS.dbo.FSA_ORDR fo1 WITH (NOLOCK)   
     JOIN (SELECT ORDR_ID,FTN,PRNT_FTN,ORDR_TYPE_CD,RELTD_FTN FROM COWS.dbo.FSA_ORDR WITH (NOLOCK)   
      WHERE ORDR_ACTN_ID <> 3 AND PRNT_FTN IS NOT NULL  
     ) fo2 ON fo2.PRNT_FTN = fo1.FTN  
    ) fo ON fo.ORDR_ID1=ont.ORDR_ID  
    LEFT OUTER JOIN COWS.dbo.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID]=ont.CREAT_BY_USER_ID  
    WHERE ont.NTE_TYPE_ID IN (9,10) AND ont.CREAT_BY_USER_ID <> 1   
    GROUP BY ont.ORDR_ID, ont.CREAT_BY_USER_ID, DSPL_NME,[ORDR_ID1],[ORDR_ID2]    
   )c  
   LEFT OUTER JOIN (SELECT * FROM COWS.dbo.USER_WFM_ASMT WITH (NOLOCK) WHERE GRP_ID = 1) uwa ON uwa.ORDR_ID=c.ORDR_ID2  
   LEFT OUTER JOIN COWS.dbo.LK_USER lku WITH (NOLOCK) ON lku.[USER_ID]=uwa.ASN_USER_ID  
  )cc ) cn ON cn.ORDR_ID2=o.ORDR_ID  
  LEFT OUTER JOIN (SELECT bb.ORDR_ID, bb.SOI_CD, bb.CUST_NME, bb.BR_CD, bb.CIS_LVL_TYPE, CONVERT(varchar, DecryptByKey(csd.CUST_NME)) AS CUST_NME2  
    FROM COWS.dbo.FSA_ORDR_CUST bb WITH (NOLOCK)  
    LEFT OUTER JOIN COWS.dbo.FSA_ORDR cc WITH (NOLOCK) ON  bb.ORDR_ID = cc.ORDR_ID   
    LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=bb.FSA_ORDR_CUST_ID  AND csd.SCRD_OBJ_TYPE_ID=5  
   WHERE (CIS_LVL_TYPE IN ( 'H5','H6')) AND bb.SOI_CD = (SELECT MAX(SOI_CD)  
     FROM (SELECT SOI_CD, ORDR_ID   
      FROM [COWS].[dbo].[FSA_ORDR_CUST] WITH (NOLOCK)) soi  
     WHERE soi.ORDR_ID = bb.ORDR_ID AND (CIS_LVL_TYPE IN ( 'H5','H6')))) si ON si.ORDR_ID = fo.ORDR_ID   
 WHERE (ipo.ORDR_ID IS NOT NULL OR fo.FTN IS NOT NULL)  
  --AND lu.MGR_ADID = 'tll4514'   
  AND ((fo.CREAT_DT >= @startDate AND fo.CREAT_DT < @endDate) OR (ipo.CREAT_DT >= @startDate AND ipo.CREAT_DT < @endDate))   
  AND ((lpt.PROD_TYPE_DES <> '') OR (lfpt.FSA_PROD_TYPE_DES <> 'Dedicated IP'))  
  AND ((ipo.H5_CUST_ACCT_NBR IS NOT NULL) OR (si.CIS_LVL_TYPE IN ( 'H5','H6')))  
  AND ((LEFT(Convert(varchar (20),ipo.ORDR_ID),2) <> '99')   
    OR (LEFT(Convert(varchar (20),fo.FTN),2) <> '99'))  
  AND o.DMSTC_CD = 1  
  
  
    
  
    
 CLOSE SYMMETRIC KEY FS@K3y   
  
 RETURN 0;  
   
END TRY  
  
BEGIN CATCH  
 DECLARE @Desc VARCHAR(200)  
 SET @Desc='EXEC COWS_Reporting.dbo.sp_GOMRptOpsDataReport '  + CAST(@QueryNumber AS VARCHAR(4)) + ': '  
 SET @Desc=@Desc + CONVERT(VARCHAR(10), @startDate, 101) + ', ' + CONVERT(VARCHAR(10), @endDate, 101)  
 EXEC RAD_Reporting.rad.sp_ReportProcessLog null, @Desc, null, null, null;  
 RETURN 1;  
END CATCH  
  
  
  